<?php

namespace FiloBlu\ExtEbizmartsMailChimp\Cron;

class UpdateMailChimpData {

    protected $_helperMailChimp;

    /**
     * Subscribers collection
     *
     * @var \Magento\Newsletter\Model\ResourceModel\Subscriber\Collection
     */
    protected $_subscribersCollection;
    protected $scopeConfig;
    protected $_loggerCron;

    public function __construct(
    \Magento\Newsletter\Model\ResourceModel\Subscriber\CollectionFactory $subscriberCollectionFactory, \FiloBlu\ExtEbizmartsMailChimp\Helper\Data $helperMailchimp, \Magento\Framework\App\Config\ScopeConfigInterface $scopeConfig, \FiloBlu\ExtEbizmartsMailChimp\Model\Logger\LoggerCron $loggerCron
    ) {
        $this->_helperMailChimp = $helperMailchimp;
        $this->_subscribersCollection = $subscriberCollectionFactory->create();
        $this->scopeConfig = $scopeConfig;
        $this->_loggerCron = $loggerCron;
    }

    public function execute() {

        if ($this->_helperMailChimp->isCronEnabled()) {
            try {

                $this->_loggerCron->info(" #### START CRON #### ");

                $subscribers = $this->_subscribersCollection->addFieldToSelect('subscriber_id')->useOnlySubscribed()->load();

                $subscriberIds = [];

                foreach ($subscribers as $subscriber) {
                    $subscriberIds[] = $subscriber->getId();
                }

                $this->_loggerCron->info(" #### SUBSCRIBER COUNT -> " . count($subscriberIds) . " #### ");
                
                $updated = $this->_helperMailChimp->sendToMailchimp($subscriberIds);
                
                $this->_loggerCron->info(" #### SUBSCRIBER UPDATED ON MAILCHIMP -> " . $updated . " #### ");
                
            } catch (\Exception $e) {
                $this->_loggerCron->info(" #### ERROR -> " . $e->getMessage() . " #### ");
            }
        }
    }

}
